import _common

class AAWheel(object):

    def __init__(self):
        self.apis = [
            {
                'method': 'POST',
                'name': '/api/v1/user/login',
                'desc': '登录',
                'group': '!AAActivity',
                'url': 'https://wheel-test.kingsome.cn/api/v1/user/login',
                'headers': _common.MaybeJwtHeader,
                'is_json_params': True,
                'request_params': [
                ],
                'params': [
                    ['token', '', 'token'],
                ],
                'response': [
                    _common.RspHead(),
                    ['info', _common.WheelUser(), '用户名'],
                ]
            },
            {
                'method': 'POST',
                'name': '/api/v1/roll_dice',
                'desc': '掷骰子',
                'group': '!AAActivity',
                'url': 'https://wheel-test.kingsome.cn/api/v1/roll_dice',
                'headers': _common.JwtHeader,
                'is_json_params': True,
                'params': [
                ],
                'response': [
                    _common.RspHead(),
                ]
            },
            {
                'method': 'GET',
                'name': '/api/v1/friend/list',
                'desc': '好友列表',
                'group': '!AAActivity',
                'url': 'https://wheel-test.kingsome.cn/api/v1/friend/list',
                'headers': _common.JwtHeader,
                'params': [
                ],
                'response': [
                    _common.RspHead(),
                ]
            },
            {
                'method': 'GET',
                'name': '/api/v1/friend/invite',
                'desc': '好友邀请',
                'group': '!AAActivity',
                'url': 'https://wheel-test.kingsome.cn/api/v1/friend/invite',
                'headers': _common.JwtHeader,
                'params': [
                ],
                'response': [
                    _common.RspHead(),
                ]
            },
            {
                'method': 'GET',
                'name': '/api/v1/friend/agree',
                'desc': '好友邀请',
                'group': '!AAActivity',
                'url': 'https://wheel-test.kingsome.cn/api/v1/friend/agree',
                'headers': _common.JwtHeader,
                'params': [
                ],
                'response': [
                    _common.RspHead(),
                ]
            },
            {
                'method': 'GET',
                'name': '/api/v1/mission/list',
                'desc': '任务列表',
                'group': '!AAActivity',
                'url': 'https://wheel-test.kingsome.cn/api/v1/mission/list',
                'headers': _common.JwtHeader,
                'params': [
                ],
                'response': [
                    _common.RspHead(),
                ]
            },
            {
                'method': 'GET',
                'name': '/api/v1/chip/list',
                'desc': '芯片列表',
                'group': '!AAActivity',
                'url': 'https://wheel-test.kingsome.cn/api/v1/chip/list',
                'headers': _common.JwtHeader,
                'params': [
                ],
                'response': [
                    _common.RspHead(),
                ]
            },
            {
                'method': 'GET',
                'name': '/api/v1/item/list',
                'desc': '道具列表',
                'group': '!AAActivity',
                'url': 'https://wheel-test.kingsome.cn/api/v1/item/list',
                'headers': _common.JwtHeader,
                'params': [
                ],
                'response': [
                    _common.RspHead(),
                ]
            },
            {
                'method': 'GET',
                'name': '/api/v1/shop/goods',
                'desc': '商店-商品列表',
                'group': '!AAActivity',
                'url': 'https://wheel-test.kingsome.cn/api/v1/shop/goods',
                'headers': _common.JwtHeader,
                'params': [
                ],
                'response': [
                    _common.RspHead(),
                ]
            },
        ]
