# -*- coding: utf-8 -*-

import _common

class Activity(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'getInviteActivityInfo',
                'desc': '拉新活动信息',
                'group': 'Activity',
                'url': 'webapp/index.php?c=Activity&a=getInviteActivityInfo',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['invitation_code', 0, '邀请码'],
                    ['invite_count', 0, '成功邀请人数'],
                    ['bind_state', 0, '绑定状态 1:已绑 0:未绑'],
                    ['reward_state', 0, '奖励状态 1:已领取 0:未领取'],
                    ['!bind_rewards', [_common.AwardItem()], '绑定奖励'],
                ]
            },{
                'name': 'bindInvitationCode',
                'desc': '绑定邀请码',
                'group': 'Activity',
                'url': 'webapp/index.php?c=Activity&a=bindInvitationCode',
                'params': [
                    _common.ReqHead(),
                     ['code', 0, '邀请码'],
                ],
                'response': [
                    _common.RspHead(),
                ]
            },{
                'name': 'getBindRewardS',
                'desc': '领取绑定奖励',
                'group': 'Activity',
                'surl': 'webapp/index.php?c=Activity&a=getBindRewardS',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['award', _common.Award(), '奖励信息'],
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },{
                'name': 'getInvitationTaskList',
                'desc': '拉新任务列表',
                'group': 'Activity',
                'url': 'webapp/index.php?c=Activity&a=getInvitationTaskList',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['!task_list',[_common.Mission()], '奖励信息'],
                ]
            },{
                'name': 'commitInvitationTaskS',
                'desc': '提交任务(领取奖励)',
                'group': 'Activity',
                'surl': 'webapp/index.php?c=Activity&a=commitInvitationTaskS',
                'params': [
                    _common.ReqHead(),
                    ['mission_id', 0, '任务id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['award', _common.Award(), '奖励信息'],
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },
        ]

