# -*- coding: utf-8 -*-

import _common

class BattleHistory(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'getBattleList',
                'desc': '历史战绩',
                'group': 'BattleHistory',
                'url': 'webapp/index.php?c=BattleHistory&a=getBattleList',
                'params': [
                    _common.ReqHead(),
                    ['target_id', '', ' 用户 account'],
                    ['type', '', ' 1:pvp 2:moba 3:巡回模式'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!data', [BattleSettlementInfo()], '战绩数据'],
                ]
            },{
                'method': 'GET',
                'name': 'showBattleHistory',
                'desc': '战绩详情',
                'group': 'BattleHistory',
                'url': 'webapp/index.php?c=BattleHistory&a=showBattleHistory',
                'params': [
                    _common.ReqHead(),
                     ['target_id', '', ' target_id'],
                     ['battle_uuid', '', ' 战斗唯一id'],
                     ['room_uuid', '', ' 房间唯一id']
                ],
                'response': [
                    _common.RspHead(),
                    ['!info', [_common.BattleSettlement()], '战绩详情'],
                ]
            },
        ]




class BattleSettlementInfo(object):

    def __init__(self):
        self.fields = [
            ['map_mode_id', 0, '模式id'],
            ['room_mode', 0, '  0:pvp  2:moba'],
            ['pvp_mode', 0, '   0:匹配 1:排位'],
            ['team_mode', 0, '  1:单人  2:多人'],
            ['pvp_team_kills', 0, '队伍击杀'],
            ['pvp_team_rank', 0, '队伍排名'],
            ['game_time', 0, '游戏结束时间'],
            ['dead_times', 0, '死亡次数'],
            ['account_id', 0, '账号id(真人才有account_id)'],
            ['name', '', '玩家名字'],
            ['head', 0, '头像id'],
            ['head_frame', 0, '头像框'],
            ['sex', 0, '性别'],
            ['hero_uniid', 0, '英雄uniid'],
            ['hero_id', 0, '英雄itemId'],
            ['dead', 0, '是否已死亡'],
            ['dead_times', 0, '死亡次数'],
            ['is_mvp', 0, '是否mvp'],
            ['old_rank', 0, '老段位'],
            ['new_rank', 0, '新段位'],
            ['old_score', 0, '老段位积分'],
            ['new_score', 0, '新段位积分'],
            ['old_circuit_score', 0, '巡回赛老积分'],
            ['new_circuit_score', 0, '巡回赛新积分'],
            ['pvp_kill', 0, 'pvp击杀敌人数'],
            ['pvp_damage', 0, 'pvp伤害总量'],
            ['pvp_assist', 0, 'pvp助攻'],
            ['pvp_survia_time', 0, 'pvp存活时间(毫秒)'],
            ['pvp_recover', 0, 'pvp治疗总量'],
            ['pvp_rescue', 0, 'pvp救援'],
            ['pvp_personal_rank', 0, '个人排名'],
            ['pve_order', 0, 'pve波次'],
            ['pve_score', 0, 'pve分数'],
            ['pve_star', 0, 'pve星'],
            ['pve_damage', 0, 'pve伤害总量'],
            ['pve_revive', 0, 'pve复活次数'],
            ['pve_survia_time', 0, 'pvp存活时间(毫秒)'],
            ['pve_wave', 0, 'pve波次'],
            ['pve_max_wave', 0, 'pve总波次'],
            ['pve_boss_killed', 0, 'pve副本boos是否被击杀'],
            ['hero_lv', 0, '英雄等级'],
            ['!reward', [_common.BattleItemReward()], 'reward'],
        ]

