# -*- coding: utf-8 -*-

import _common

class Bigwheel(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'info',
                'desc': '转盘信息',
                'group': 'Bigwheel',
                'url': 'webapp/index.php?c=Bigwheel&a=info',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['info', _common.BigwheelInfo(), '转盘信息'],
                ]
            },
            {
                'name': 'drawS',
                'desc': '抽奖',
                'group': 'Bigwheel',
                'url': 'webapp/index.php?c=Bigwheel&a=drawS',
                'params': [
                    _common.ReqHead(),
                    ['type', 0, '0:双勾选 1:第1档 2:第2档']
                ],
                'response': [
                    _common.RspHead(),
                    ['award', _common.Award(), '奖励信息'],
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                    ['info', _common.BigwheelInfo(), '转盘信息'],
                    ['!prizes', [_common.BigwheelGrid()], '奖品列表']
                ]
            },
            {
                'name': 'buyS',
                'desc': '购买',
                'group': 'Bigwheel',
                'url': 'webapp/index.php?c=Bigwheel&a=buyS',
                'params': [
                    _common.ReqHead(),
                    ['grid_id', 0, '格子id']
                ],
                'response': [
                    _common.RspHead(),
                    ['award', _common.Award(), '奖励信息'],
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                    ['info', _common.BigwheelInfo(), '转盘信息'],
                ]
            }
        ]
