import _common

class HashRate(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'taskList',
                'desc': '获取算力信息',
                'group': 'HashRate',
                'url': 'webapp/index.php?c=HashRate&a=taskList',
                'params': [
                    _common.ReqHead(),
                    ['type', 0, '1:战斗任务 2:英雄任务 3:行为任务 4:充值消费任务'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!task_list1', [HashRateList()], '任务列表1'],
                    ['!task_list2', [HashRateList()], '任务列表2'],
                    ['obtain_start_time', 0, '获得期开始时间'],
                    ['obtain_end_time', 0, '获得期结束时间'],
                    ['income_start_time', 0, '盈利期开始时间'],
                    ['income_end_time', 0, '盈利期结束时间'],
                    ['state', 0, '0:未开始 1:获得期 2:盈利期'],
                    ['myHashRate', 0, '我的算力'],
                    ['goldRate', 0, '金币加成'],
                    ['refresh_times', 0, '今日刷新次数'],
                ]
            },{
                'name': 'commitTaskS',
                'desc': '获取算力信息',
                'group': 'HashRate',
                'surl': 'webapp/index.php?c=HashRate&a=commitTaskS',
                'params': [
                    _common.ReqHead(),
                    ['task_id', 0, '任务id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!award', [_common.AwardItem()], '奖励'],
                ]
            },{
                'name': 'refreshTask',
                'desc': '刷新任务行为',
                'group': 'HashRate',
                'url': 'webapp/index.php?c=HashRate&a=refreshTask',
                'params': [
                    _common.ReqHead(),
                    ['task_id', 0, '任务id'],
                ],
                'response': [
                    _common.RspHead(),
                ]
            },{
                'name': 'redTips',
                'desc': '红点提示',
                'group': 'HashRate',
                'url': 'webapp/index.php?c=HashRate&a=redTips',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                   ['!tips', [], '任务类型'],
                ]
            },
        ]


class HashRateList(object):

    def __init__(self):
        self.fields = [
            ['task_id', 0, '任务id'],
            ['current', 0, '当前进度'],
            ['target', 0, '目标进度'],
            ['state', 0, '2:完成(已领取) 1:完成(未领取) 0:未完成'],
        ]