# -*- coding: utf-8 -*-

import _common

class Hero(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'heroList',
                'desc': '获取英雄列表',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=heroList',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['!hero_list', [_common.Hero()], '英雄列表']
                ]
            },
            {
                'name': 'heroDetails',
                'desc': '英雄详情',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=heroDetails',
                'params': [
                    _common.ReqHead(),
                    ['unique_id', 0, '英雄唯一id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!data',  [_common.Hero()], '英雄信息']
                ]
            },
           {
                'name': 'setHeroSkill',
                'desc': '设置通用技能',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=setHeroSkill',
                'params': [
                    _common.ReqHead(),
                    ['skill_id', 0, '技能id'],
                ],
                'response': [
                    _common.RspHead(),
                ]
            },{
                'name': 'presetHero',
                'desc': '英雄预设',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=presetHero',
                'params': [
                    _common.ReqHead(),
                    ['hero_uid', 0, '英雄唯一id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['data', _common.HeroPreset(), '预设信息']
                ]
            },{
                'name': 'applyHero',
                'desc': '应用',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=applyHero',
                'params': [
                    _common.ReqHead(),
                    ['hero_uid', 0, '英雄唯一id'],
                    ['skill_id', 0, '技能itemId'],
                    ['weapon_uid1', 0, '武器1唯一id'],
                    ['weapon_uid2', 0, '武器2唯一id'],
                    ['chip_page', 0, '芯片页id'],
                ],
                'response': [
                    _common.RspHead(),
                ]
            },{
                'name': 'upgradeQualityS',
                'desc': '英雄升阶',
                'group': 'Hero',
                'surl': 'webapp/index.php?c=Hero&a=upgradeQualityS',
                'params': [
                    _common.ReqHead(),
                    ['hero_uniid', 0, '英雄唯一id'],
                    ['item_id', 0, '碎片item_id'],
                    ['item_num', 0, '碎片数量'],
                    ['extra_item', 0, '附加道具(选填)'],
                    ['extra_num', 0, '附加道具数量(选填)'],
                ],
                'response': [
                    _common.RspHead(),
                      ['status', 0, '1:成功 0:失败'],
                      ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },
            {
                'name': 'unSealHero',
                'desc': '英雄解封',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=unSealHero',
                'params': [
                    _common.ReqHead(),
                    ['hero_uniid', 0, '英雄唯一id'],
                ],
                'response': [
                    _common.RspHead(),
                      ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },{
                'name': 'synHeroS',
                'desc': '英雄合成',
                'group': 'Hero',
                'surl': 'webapp/index.php?c=Hero&a=synHeroS',
                'params': [
                    _common.ReqHead(),
                    ['item_id', 0, '碎片item_id'],
                    ['item_num', 0, '碎片数量'],
                ],
                'response': [
                    _common.RspHead(),
                      ['item_id', 0, '英雄item_id'],
                      ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },

        ]
