import _common

class Other(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'tag',
                'desc': '红点提示',
                'group': 'Other',
                'url': 'webapp/index.php?c=Other&a=tag',
                'params': [
                    _common.ReqHead(),
                     ['types', '', '红点类型(!!!注意由于红点的计算量较大，最好并发分批取红点状态)","分割 1:英雄 2:芯片 3:背包 4:签到 5:算力 6:皮肤 7:新人任务 8:日周常任务 9:拉新任务'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!list', [Tag()], '红点列表']
                ]
            },{
                'name': 'cancelTag',
                'desc': '红点提示',
                'group': 'Other',
                'url': 'webapp/index.php?c=Other&a=cancelTag',
                'params': [
                    _common.ReqHead(),
                     ['type', '', '1:英雄 2:芯片 3:背包  5:算力 6:皮肤'],
                     ['item_unnid', '', 'item_unnid'],
                ],
                'response': [
                    _common.RspHead(),
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },
            {
                'name': 'getGameModuleState',
                'desc': '功能模块的状态',
                'group': 'Other',
                'url': 'webapp/index.php?c=Other&a=getGameModuleState',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['data', [
                        ['firstTopUp',0,'首充: 1 已充, 0 未充'],
                        ['signDayState',0,'7日签到: 1 签满, 0 未签满'],
                        ['rankState',0,'排位: 1 赛季开始了, 0 赛季未开始'],
                        ['nextRankSeasonCountdown',0,'下赛季倒计时'],
                        ['hashRateState',0,'算力: 1 开始, 0 未开始'],
                    ], '信息'],
                ]
            },
            {
                'name': 'getCecRewardHistory',
                'desc': 'cec历史记录界面',
                'group': 'Other',
                'url': 'webapp/index.php?c=Other&a=getCecRewardHistory',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['!list', [
                        ['type',0,'1:排位 2:算力 3:质押'],
                        ['cecVal',0,'cec数量'],
                        ['createtime',0,'获取时间']
                    ], '历史记录'],
                    ['cec',0,'cec'],
                ]
            },
            {
                'name': 'getMapModeList',
                'desc': '获取当前开启的地图模式列表',
                'group': 'Other',
                'url': 'webapp/index.php?c=Other&a=getMapModeList',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['!mode_list', [
                        ['id',0,'mapMode配置id'],
                        ['task_state',0,'巡回赛状态 0:未开 1:已开,id=7(巡回模式)才有'],
                        ['stage_state',0,'阶段开始状态 0:未开 1:已开,id=7(巡回模式)才有'],
                        ['next_star_time',0,'下个阶段开始时间,id=7(巡回模式)才有'],
                        ['next_end_time',0,'下个阶段结束时间,id=7(巡回模式)才有'],
                        ['state',0,'开启状态 0:未开 1:已开,特殊模式才有(见mapMode配置表)'],
                        ['daily_open_time',0,'每天开始时间1,特殊模式才有(见mapMode配置表)'],
                        ['daily_end_time',0,'每天结束时间1,特殊模式才有(见mapMode配置表)'],
                        ['daily_open_time_2',0,'每天开始时间2,特殊模式才有(见mapMode配置表)'],
                        ['daily_end_time_2',0,'每天结束时间2,特殊模式才有(见mapMode配置表)'],
                    ], '地图模式列表'],
                ]
            },
            {
                'name': 'getServerSwitch',
                'desc': '开关信息',
                'group': 'Other',
                'url': 'webapp/index.php?c=Other&a=getServerSwitch',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['data', [
                        ['heroChain',0,'英雄上链'],
                        ['heroUp',0,'英雄升阶'],
                        ['goldSyn',0,'金币合成'],
                        ['heroPieceSyn',0,'英雄碎片合成'],
                        ['chipPieceSyn',0,'芯片碎片合成'],
                        ['shop',0,'商店'],
                    ], '开关信息(如果没有则默认为未开启)'],
                ]
            },
        ]

class Tag(object):

    def __init__(self):
        self.fields = [
            ['type', 0, '红点类型'],
            ['state', 0, '红点状态 0:无 1:有'],
        ]
