import _common

class OutAppTools(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'getCircuitRanking',
                'desc': '巡回赛赛季排行',
                'group': 'OutAppCircuit',
                'url': 'webapp/index.php?c=OutAppCircuit&a=getCircuitRanking',
                'params': [
                    ['address', '0', 'address'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!rank_list', [rankingInfo()], '榜'],
                    ['info', circuitInfo(), '信息'],
                ]
            },{
                'name': 'getCircuitPhaseRanking',
                'desc': '巡回赛周期排行',
                'group': 'OutAppCircuit',
                'url': 'webapp/index.php?c=OutAppCircuit&a=getCircuitPhaseRanking',
                'params': [
                    ['address', '0', 'address'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!rank_list', [rankingInfo()], '榜'],
                    ['info', circuitInfo(), '信息'],
                ]
            },{
                'name': 'getCircuitRewardHistory',
                'desc': '获取巡回赛奖励记录',
                'group': 'OutAppCircuit',
                'url': 'webapp/index.php?c=OutAppCircuit&a=getCircuitRewardHistory',
                'params': [
                    ['address', '0', 'address'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!data', [rewardInfo()], '奖励信息'],
                ]
            },{
                'name': 'circuitSettlement',
                'desc': '巡回赛结算奖励',
                'group': 'OutAppCircuit',
                'url': 'webapp/index.php?c=OutAppCircuit&a=circuitSettlement',
                'params': [
                ],
                'response': [
                    _common.RspHead(),
                ]
            },

        ]


class rewardInfo(object):

    def __init__(self):
        self.fields = [
             ['start_time', 0, '阶段开始时间'],
             ['end_time', 0, '阶段结束时间'],
             ['reward', 0, '-1:未结算 0:结算无奖励'],
        ]

class circuitInfo(object):

    def __init__(self):
        self.fields = [
             ['start_time', 0, '开始时间'],
             ['end_time', 0, '结束时间'],
             ['ranking', 0, '排名'],
             ['score', 0, '积分'],
        ]

class rankingInfo(object):

    def __init__(self):
        self.fields = [
            ['account_id', 0, 'account'],
            ['name', 0, '名字'],
            ['head_id', 0, '头像'],
            ['head_frame', 0, '头像框'],
            ['hero_id', 0, '英雄ItemId'],
            ['skin_id', 0, '皮肤ItemId'],
            ['ranking', 0, '排名'],
            ['score', 0, '积分'],
            ['score_boost', 0, '加成的积分'],
            ['cec', 0, 'cec(个人榜信息才有)'],
        ]