# -*- coding: utf-8 -*-

import _common

class RookieTask(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'bindRookieTask',
                'desc': '记录用户新人任务开启',
                'group': 'RookieTask',
                'url': 'webapp/index.php?c=RookieTask&a=bindRookieTask',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                ]
            },{
                'name': 'taskList',
                'desc': '新人任务列表',
                'group': 'RookieTask',
                'url': 'webapp/index.php?c=RookieTask&a=taskList',
                'params': [
                    _common.ReqHead(),
                    ['day', 0, '天'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!task_list1', [Task()], '任务列表1'],
                    ['!task_list2', [Task()], '任务列表2'],
                ]
            },{
                'name': 'commitTaskS',
                'desc': '提交任务',
                'group': 'RookieTask',
                'surl': 'webapp/index.php?c=RookieTask&a=commitTaskS',
                'params': [
                    _common.ReqHead(),
                    ['task_id', 0, '任务id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['award', _common.Award(), '奖励信息'],
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },{
                'name': 'getTaskRedTags',
                'desc': '任务红点',
                'group': 'RookieTask',
                'url': 'webapp/index.php?c=RookieTask&a=getTaskRedTags',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['list', [], '红点信息'],
                ]
            },
        ]


class Task(object):

    def __init__(self):
        self.fields = [
            ['task_id', 0, '任务id'],
            ['current', 0, '任务进度-当前'],
            ['target', 0, '任务进度-目标'],
            ['state', 0, '任务状态 0:未完成 1:完成未领取 2:完成已领取 3:未到时间'],
        ]