<?php


namespace models;

use mt;
use phpcommon\SqlHelper;
class GlobalData extends BaseModel
{
    public static function getServerTaskData(){
        $db = self::internalGet('server_event_data');
        return $db ? json_decode($db['data'], true) : array();
    }

    public static function addServerTaskData($battleData){
        self::internalGetAdd("server_event_data",json_encode($battleData));
    }

    public static function getServerTaskStatus(){
        $db = self::internalGet('server_event_status');
        return $db ? json_decode($db['data'], true) : 0;
    }

    public static function addServerTaskStatus($value){
        self::internalGetAdd("server_event_status",json_encode($value));
    }

    private static function internalGetAdd($name,$battleData)
    {
        SqlHelper::upsert
        (myself()->_getSelfMysql(),
            't_global_data',
            array(
                'name' =>$name,
            ),
            array(
                'data' => $battleData,
                'modifytime' => myself()->_getNowTime(),
            ),
            array(
                'name' => $name,
                'data' => $battleData,
                'createtime' => myself()->_getNowTime(),
                'modifytime' => myself()->_getNowTime()
            )
        );
    }

    private static function internalGet($name)
    {
        $row = SqlHelper::ormSelectOne
        (myself()->_getMysql(''),
            't_global_data',
            array(
                'name' => $name
            )
        );
        return $row ? $row : '';
    }

    public static function addUserChartData($battleData){
        self::internalGetAdd("user_chart_data",json_encode($battleData));
    }

    public static function getUserChartData(){
        $db = self::internalGet('user_chart_data');
        return $db ? json_decode($db['data'], true) : array();
    }

}