<?php

namespace services;

require_once('mt/Bigwheel.php');

use mt;

class BigwheelService extends BaseService
{

    public static function onWinPrize($grid1, $grid2)
    {
        $grids = array($grid1, $grid2);
        foreach ($grids as $grid) {
            $gridMeta = mt\Bigwheel::get($grid['info']['grid_id']);
            if ($grid['info']['grid_state'] == 1 && $gridMeta['is_grand_reward']) {
                self::sendNotify($grid['drop'][0]['item_id']);
            }
        }
        myself()->_addTgLog('Bigwheel.WinPrize', array(
            'grid1' => $grid1,
            'grid2' => $grid2
        ));
    }

    private static function sendNotify($itemId)
    {
        $itemMeta = myself()->_callMtStatic('Item', 'get', $itemId);
        if (empty($itemMeta)) {
            return;
        }
        $elements = array();
        array_push($elements, array(
            'ele_type' => 2,
            'color' => '#ffffff',
            'lang_key' => 'Marquee_rewards_get_1',
            'lang_params' => array(),
        ));
        array_push($elements, array(
            'ele_type' => 1,
            //'color' => '#',
            'text' => myself()->_getUserInfo(array('name'))['name'],
        ));
        array_push($elements, array(
            'ele_type' => 2,
            'color' => '#ffffff',
            'lang_key' => 'Marquee_rewards_get_2',
            'lang_params' => array(),
        ));
        array_push($elements, array(
            'ele_type' => 2,
            'color' => '#ff3f3f',
            'lang_key' => $itemMeta['name'],
            'lang_params' => array(),
        ));
        array_push($elements, array(
            'ele_type' => 2,
            'color' => '#ffffff',
            'lang_key' => 'Marquee_rewards_get_3',
            'lang_params' => array(),
        ));
//        error_log(json_encode($elements));
        $content = myself()->_callServiceStatic('NoticeService', 'buildCustom', $elements);
        $loop = 1;
        $interval = 1;
        myself()->_callServiceStatic('NoticeService', 'send', $content, $loop, $interval);
    }

}
